<template>
    <div class="edit-view">
        <el-form
            :model="formData"
            :rules="rules"
            ref="form"
            label-width="90px"
            label-position="right"
            size="small"
            style="max-width: 500px;"
        >
            <el-form-item prop="attractionsId" label="景区">
                <el-select
                    v-model="formData.attractionsId"
                    clearable
                    filterable
                    placeholder="请选择景区"
                    class="cl-input"
                >
                    <el-option
                        v-for="item in attractionsOptions"
                        :key="item.value"
                        :label="item.label"
                        :value="item.value"
                    >
                    </el-option>
                </el-select>
            </el-form-item>
            <el-form-item prop="img" label="图片">
                <single-upload v-model="formData.img"></single-upload>
            </el-form-item>
            <el-form-item prop="name" label="名称">
                <el-input v-model="formData.name" class="cl-input"></el-input>
            </el-form-item>
            <el-form-item prop="price" label="价格">
                <el-input-number v-model="formData.price" class="cl-input"></el-input-number>
            </el-form-item>
            <el-form-item prop="unit" label="单位">
                <el-input v-model="formData.unit" class="cl-input"></el-input>
            </el-form-item>
            <el-form-item prop="categoryId" label="类型">
                <el-select v-model="formData.categoryId" clearable filterable placeholder="请选择" class="cl-input">
                    <el-option
                        v-for="item in categoryOptions"
                        :key="item.value"
                        :label="item.label"
                        :value="item.value"
                    >
                    </el-option>
                </el-select>
            </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="saving" type="primary">保存</el-button>
                <el-button @click="onDelete" :loading="saving" type="danger" v-if="formData.id">删除 </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
export default {
    name: 'GoodsInfoEdit',
    created() {
        if (this.$route.query.id) {
            this.$http
                .get('goodsInfo/get/' + this.$route.query.id)
                .then(res => {
                    this.formData = res;
                })
                .catch(e => {
                    console.log(e);
                    this.$message.error(e.error);
                });
        }
        this.$http
            .post('/category/getChildren', { id: 730 })
            .then(res => {
                if (res.length > 0) {
                    res.forEach(item => {
                        this.categoryOptions.push({
                            label: item.name,
                            value: item.id
                        });
                    });
                }
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
        this.$http
            .post('/attractions/all', { size: 1000, query: { del: false } }, { body: 'json' })
            .then(res => {
                if (res.content.length > 0) {
                    res.content.forEach(item => {
                        this.attractionsOptions.push({
                            label: item.name,
                            value: item.id
                        });
                    });
                }
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
    },
    data() {
        return {
            saving: false,
            formData: {},
            rules: {
                name: [
                    {
                        required: true,
                        message: '请输入名称',
                        trigger: 'blur'
                    }
                ]
            },
            categoryOptions: [],
            attractionsOptions: []
        };
    },
    methods: {
        onSave() {
            this.$refs.form.validate(valid => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            let data = { ...this.formData };

            this.saving = true;
            this.$http
                .post('/goodsInfo/save', data, { body: 'json' })
                .then(res => {
                    this.saving = false;
                    this.$message.success('成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    console.log(e);
                    this.saving = false;
                    this.$message.error(e.error);
                });
        },
        onDelete() {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/goodsInfo/del/${this.formData.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                });
        }
    }
};
</script>
<style lang="less" scoped>
.cl-input {
    width: 350px;
}
</style>
